<?php

/*
Plugin Name: Lucipress
Plugin URI: http://luci.fm
Description: Podcast by uploading files to a ftp server with <a href="http://www.luci.eu">Luci</a>, the mobile broadcasting software.
Author: Robert Buzink & Joost Bloemen
Version: 1.2
Author URI: http://luci.fm
*/ 

/*
Lucipress
Licensed under the GPL License

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated
documentation files (the "Software"), to deal in the
Software without restriction, including without limitation
the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to
do so, subject to the following conditions:

The above copyright notice and this permission notice shall
be included in all copies or substantial portions of the
Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS
OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

include('lucipress.class.php');

add_action('activate_Lucipress/Lucipress.php','Lucipress_install');
add_action('admin_menu', 'Lucipress_add_page');
//add_action('shutdown', 'Lucipress_trigger_php');
add_action('wp_footer', 'Lucipress_trigger_html');
add_filter('the_content', 'Lucipress_replacetag');
add_filter('the_excerpt','Lucipress_replacetag');
add_action('wp_head', 'Lucipress_head');



// a trigger that can be used as an action.
// when wrong domain entered, page loading takes 60 seconds
// returns errors when wrong username, password, directory, etc.
function Lucipress_trigger_php () {
	
	$FTPod = new Lucipress();
	$FTPod->load_options();
	$FTPod->insert_podposts();

}

// a trigger that can be used as an action.
// loads a php script as an image
// when wrong domain entered, image loading takes 60 seconds
// but page is displayed immediately
function Lucipress_trigger_html () {

//	$url = get_settings('home')."/wp-content/plugins/Lucipress/fire.php";
 //	echo "<iframe src='$url' name='mailiframe' width='0' height='0' frameborder='0' scrolling='no' title='Get new Lucipress podcast(s)'>";
	$url = get_settings('home')."/wp-content/plugins/Lucipress/fire.php?return_image=1";
	echo "<img src='$url' width='1' height='1'>";

}

function Lucipress_replacetag($the_content) {
	$FTPod = new Lucipress();
	if(strpos($the_content, "[mp2=")!==FALSE) { // Check whether any brackets are present to prevent any unnecessary preg_matching
		preg_match_all("/\[mp2=([^\]]*)\]/", $the_content, $matches, PREG_SET_ORDER); // match all references and sort them into a nice array

		foreach($matches as $match) { // Go through matches and replace them
			$the_content = preg_replace("/\[mp2=([^\]]*)\]/", $FTPod->mp2tag_replace($match[1]), $the_content, 1);
		}
	}

	if(strpos($the_content, "[3gp=")!==FALSE) { // Check whether any brackets are present to prevent any unnecessary preg_matching
		preg_match_all("/\[3gp=([^\]]*)\]/", $the_content, $matches2, PREG_SET_ORDER); // match all references and sort them into a nice array
		foreach($matches2 as $match) { // Go through matches and replace them
			$the_content = preg_replace("/\[3gp=([^\]]*)\]/", $FTPod->gptag_replace($match[1]), $the_content, 1);
		}
	}
	
    return $the_content;
}

function Lucipress_head(){
	$url = get_option('home')."/wp-content/plugins/Lucipress";
	$css = "\n<link rel=\"stylesheet\" type=\"text/css\" href=\"$url/lucipress.css\" />\n";
	$js = "\n<script type=\"text/javascript\" src=\"$url/qtobject.js\" ></script>\n";
	
	echo $css.$js;
}

function Lucipress_install () {
	
	$FTPod = new Lucipress();
	$FTPod->create_options();
	
}

function Lucipress_add_page () {
	
	add_options_page('Lucipress', 'Lucipress', 8, Lucipress, 'Lucipress_options_page');

}

function Lucipress_options_page () {

	$FTPad = new Lucipress();
	
	// process submitted options
	if ($_POST) {
		$FTPad->load_post_options($_POST);
		$FTPad->save_options();
	}
	
	// display options form
	$FTPad->load_options(); ?>
	<div class="wrap">
		<h1><?php echo $FTPad->ad_title; ?></h1>
		<form method="post" action="<?php echo $_SERVER['REQUEST_URI']; ?>">
			<table>
				<thead>
					<tr>
						<td>
							Option
						</td>
						<td>
							Value
						</td>
					</tr>
				</thead>
				<tbody>
<?php  $FTPad->print_options(); ?>		
					<tr>
						<td>&nbsp;
							
						</td>
						<td>&nbsp;
							
						</td>
					</tr>
					<tr align="right">
						<td>
						</td>
						<td>
							<input type='submit' name ='submit' value='Save options &raquo;'>
						</td>
					</tr>
				</tbody>
			</table>
			
		</form>
	</div>
	
	<?php

}

?>
